package com.neusoft.smart.pos.trade.persistent.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class GrantOrderMasterExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public GrantOrderMasterExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public GrantOrderMasterExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberIsNull() {
            addCriterion("grant_order_number is null");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberIsNotNull() {
            addCriterion("grant_order_number is not null");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberEqualTo(String value) {
            addCriterion("grant_order_number =", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberNotEqualTo(String value) {
            addCriterion("grant_order_number <>", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberGreaterThan(String value) {
            addCriterion("grant_order_number >", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberGreaterThanOrEqualTo(String value) {
            addCriterion("grant_order_number >=", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberLessThan(String value) {
            addCriterion("grant_order_number <", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberLessThanOrEqualTo(String value) {
            addCriterion("grant_order_number <=", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberLike(String value) {
            addCriterion("grant_order_number like", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberNotLike(String value) {
            addCriterion("grant_order_number not like", value, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberIn(List<String> values) {
            addCriterion("grant_order_number in", values, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberNotIn(List<String> values) {
            addCriterion("grant_order_number not in", values, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberBetween(String value1, String value2) {
            addCriterion("grant_order_number between", value1, value2, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andGrantOrderNumberNotBetween(String value1, String value2) {
            addCriterion("grant_order_number not between", value1, value2, "grantOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberIsNull() {
            addCriterion("outer_order_number is null");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberIsNotNull() {
            addCriterion("outer_order_number is not null");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberEqualTo(String value) {
            addCriterion("outer_order_number =", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotEqualTo(String value) {
            addCriterion("outer_order_number <>", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberGreaterThan(String value) {
            addCriterion("outer_order_number >", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberGreaterThanOrEqualTo(String value) {
            addCriterion("outer_order_number >=", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberLessThan(String value) {
            addCriterion("outer_order_number <", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberLessThanOrEqualTo(String value) {
            addCriterion("outer_order_number <=", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberLike(String value) {
            addCriterion("outer_order_number like", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotLike(String value) {
            addCriterion("outer_order_number not like", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberIn(List<String> values) {
            addCriterion("outer_order_number in", values, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotIn(List<String> values) {
            addCriterion("outer_order_number not in", values, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberBetween(String value1, String value2) {
            addCriterion("outer_order_number between", value1, value2, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotBetween(String value1, String value2) {
            addCriterion("outer_order_number not between", value1, value2, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andAuthNoIsNull() {
            addCriterion("auth_no is null");
            return (Criteria) this;
        }

        public Criteria andAuthNoIsNotNull() {
            addCriterion("auth_no is not null");
            return (Criteria) this;
        }

        public Criteria andAuthNoEqualTo(String value) {
            addCriterion("auth_no =", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoNotEqualTo(String value) {
            addCriterion("auth_no <>", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoGreaterThan(String value) {
            addCriterion("auth_no >", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoGreaterThanOrEqualTo(String value) {
            addCriterion("auth_no >=", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoLessThan(String value) {
            addCriterion("auth_no <", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoLessThanOrEqualTo(String value) {
            addCriterion("auth_no <=", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoLike(String value) {
            addCriterion("auth_no like", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoNotLike(String value) {
            addCriterion("auth_no not like", value, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoIn(List<String> values) {
            addCriterion("auth_no in", values, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoNotIn(List<String> values) {
            addCriterion("auth_no not in", values, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoBetween(String value1, String value2) {
            addCriterion("auth_no between", value1, value2, "authNo");
            return (Criteria) this;
        }

        public Criteria andAuthNoNotBetween(String value1, String value2) {
            addCriterion("auth_no not between", value1, value2, "authNo");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(Integer value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(Integer value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(Integer value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(Integer value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(Integer value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<Integer> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<Integer> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(Integer value1, Integer value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(Integer value1, Integer value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andShopIdIsNull() {
            addCriterion("shop_id is null");
            return (Criteria) this;
        }

        public Criteria andShopIdIsNotNull() {
            addCriterion("shop_id is not null");
            return (Criteria) this;
        }

        public Criteria andShopIdEqualTo(Integer value) {
            addCriterion("shop_id =", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotEqualTo(Integer value) {
            addCriterion("shop_id <>", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdGreaterThan(Integer value) {
            addCriterion("shop_id >", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_id >=", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdLessThan(Integer value) {
            addCriterion("shop_id <", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("shop_id <=", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdIn(List<Integer> values) {
            addCriterion("shop_id in", values, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotIn(List<Integer> values) {
            addCriterion("shop_id not in", values, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdBetween(Integer value1, Integer value2) {
            addCriterion("shop_id between", value1, value2, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_id not between", value1, value2, "shopId");
            return (Criteria) this;
        }

        public Criteria andSerialNoIsNull() {
            addCriterion("serial_no is null");
            return (Criteria) this;
        }

        public Criteria andSerialNoIsNotNull() {
            addCriterion("serial_no is not null");
            return (Criteria) this;
        }

        public Criteria andSerialNoEqualTo(String value) {
            addCriterion("serial_no =", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotEqualTo(String value) {
            addCriterion("serial_no <>", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoGreaterThan(String value) {
            addCriterion("serial_no >", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoGreaterThanOrEqualTo(String value) {
            addCriterion("serial_no >=", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoLessThan(String value) {
            addCriterion("serial_no <", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoLessThanOrEqualTo(String value) {
            addCriterion("serial_no <=", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoLike(String value) {
            addCriterion("serial_no like", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotLike(String value) {
            addCriterion("serial_no not like", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoIn(List<String> values) {
            addCriterion("serial_no in", values, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotIn(List<String> values) {
            addCriterion("serial_no not in", values, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoBetween(String value1, String value2) {
            addCriterion("serial_no between", value1, value2, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotBetween(String value1, String value2) {
            addCriterion("serial_no not between", value1, value2, "serialNo");
            return (Criteria) this;
        }

        public Criteria andDeviceNameIsNull() {
            addCriterion("device_name is null");
            return (Criteria) this;
        }

        public Criteria andDeviceNameIsNotNull() {
            addCriterion("device_name is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceNameEqualTo(String value) {
            addCriterion("device_name =", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotEqualTo(String value) {
            addCriterion("device_name <>", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameGreaterThan(String value) {
            addCriterion("device_name >", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameGreaterThanOrEqualTo(String value) {
            addCriterion("device_name >=", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameLessThan(String value) {
            addCriterion("device_name <", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameLessThanOrEqualTo(String value) {
            addCriterion("device_name <=", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameLike(String value) {
            addCriterion("device_name like", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotLike(String value) {
            addCriterion("device_name not like", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameIn(List<String> values) {
            addCriterion("device_name in", values, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotIn(List<String> values) {
            addCriterion("device_name not in", values, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameBetween(String value1, String value2) {
            addCriterion("device_name between", value1, value2, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotBetween(String value1, String value2) {
            addCriterion("device_name not between", value1, value2, "deviceName");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberIsNull() {
            addCriterion("customer_number is null");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberIsNotNull() {
            addCriterion("customer_number is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberEqualTo(String value) {
            addCriterion("customer_number =", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberNotEqualTo(String value) {
            addCriterion("customer_number <>", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberGreaterThan(String value) {
            addCriterion("customer_number >", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberGreaterThanOrEqualTo(String value) {
            addCriterion("customer_number >=", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberLessThan(String value) {
            addCriterion("customer_number <", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberLessThanOrEqualTo(String value) {
            addCriterion("customer_number <=", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberLike(String value) {
            addCriterion("customer_number like", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberNotLike(String value) {
            addCriterion("customer_number not like", value, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberIn(List<String> values) {
            addCriterion("customer_number in", values, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberNotIn(List<String> values) {
            addCriterion("customer_number not in", values, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberBetween(String value1, String value2) {
            addCriterion("customer_number between", value1, value2, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andCustomerNumberNotBetween(String value1, String value2) {
            addCriterion("customer_number not between", value1, value2, "customerNumber");
            return (Criteria) this;
        }

        public Criteria andSeqNoIsNull() {
            addCriterion("seq_no is null");
            return (Criteria) this;
        }

        public Criteria andSeqNoIsNotNull() {
            addCriterion("seq_no is not null");
            return (Criteria) this;
        }

        public Criteria andSeqNoEqualTo(Integer value) {
            addCriterion("seq_no =", value, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoNotEqualTo(Integer value) {
            addCriterion("seq_no <>", value, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoGreaterThan(Integer value) {
            addCriterion("seq_no >", value, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoGreaterThanOrEqualTo(Integer value) {
            addCriterion("seq_no >=", value, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoLessThan(Integer value) {
            addCriterion("seq_no <", value, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoLessThanOrEqualTo(Integer value) {
            addCriterion("seq_no <=", value, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoIn(List<Integer> values) {
            addCriterion("seq_no in", values, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoNotIn(List<Integer> values) {
            addCriterion("seq_no not in", values, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoBetween(Integer value1, Integer value2) {
            addCriterion("seq_no between", value1, value2, "seqNo");
            return (Criteria) this;
        }

        public Criteria andSeqNoNotBetween(Integer value1, Integer value2) {
            addCriterion("seq_no not between", value1, value2, "seqNo");
            return (Criteria) this;
        }

        public Criteria andGrantAmountIsNull() {
            addCriterion("grant_amount is null");
            return (Criteria) this;
        }

        public Criteria andGrantAmountIsNotNull() {
            addCriterion("grant_amount is not null");
            return (Criteria) this;
        }

        public Criteria andGrantAmountEqualTo(BigDecimal value) {
            addCriterion("grant_amount =", value, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountNotEqualTo(BigDecimal value) {
            addCriterion("grant_amount <>", value, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountGreaterThan(BigDecimal value) {
            addCriterion("grant_amount >", value, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("grant_amount >=", value, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountLessThan(BigDecimal value) {
            addCriterion("grant_amount <", value, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("grant_amount <=", value, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountIn(List<BigDecimal> values) {
            addCriterion("grant_amount in", values, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountNotIn(List<BigDecimal> values) {
            addCriterion("grant_amount not in", values, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("grant_amount between", value1, value2, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andGrantAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("grant_amount not between", value1, value2, "grantAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountIsNull() {
            addCriterion("pay_amount is null");
            return (Criteria) this;
        }

        public Criteria andPayAmountIsNotNull() {
            addCriterion("pay_amount is not null");
            return (Criteria) this;
        }

        public Criteria andPayAmountEqualTo(BigDecimal value) {
            addCriterion("pay_amount =", value, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountNotEqualTo(BigDecimal value) {
            addCriterion("pay_amount <>", value, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountGreaterThan(BigDecimal value) {
            addCriterion("pay_amount >", value, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_amount >=", value, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountLessThan(BigDecimal value) {
            addCriterion("pay_amount <", value, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_amount <=", value, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountIn(List<BigDecimal> values) {
            addCriterion("pay_amount in", values, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountNotIn(List<BigDecimal> values) {
            addCriterion("pay_amount not in", values, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_amount between", value1, value2, "payAmount");
            return (Criteria) this;
        }

        public Criteria andPayAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_amount not between", value1, value2, "payAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountIsNull() {
            addCriterion("unfreeze_amount is null");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountIsNotNull() {
            addCriterion("unfreeze_amount is not null");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountEqualTo(BigDecimal value) {
            addCriterion("unfreeze_amount =", value, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountNotEqualTo(BigDecimal value) {
            addCriterion("unfreeze_amount <>", value, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountGreaterThan(BigDecimal value) {
            addCriterion("unfreeze_amount >", value, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("unfreeze_amount >=", value, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountLessThan(BigDecimal value) {
            addCriterion("unfreeze_amount <", value, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("unfreeze_amount <=", value, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountIn(List<BigDecimal> values) {
            addCriterion("unfreeze_amount in", values, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountNotIn(List<BigDecimal> values) {
            addCriterion("unfreeze_amount not in", values, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("unfreeze_amount between", value1, value2, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andUnfreezeAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("unfreeze_amount not between", value1, value2, "unfreezeAmount");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNull() {
            addCriterion("pay_type is null");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNotNull() {
            addCriterion("pay_type is not null");
            return (Criteria) this;
        }

        public Criteria andPayTypeEqualTo(String value) {
            addCriterion("pay_type =", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotEqualTo(String value) {
            addCriterion("pay_type <>", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThan(String value) {
            addCriterion("pay_type >", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThanOrEqualTo(String value) {
            addCriterion("pay_type >=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThan(String value) {
            addCriterion("pay_type <", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThanOrEqualTo(String value) {
            addCriterion("pay_type <=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLike(String value) {
            addCriterion("pay_type like", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotLike(String value) {
            addCriterion("pay_type not like", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeIn(List<String> values) {
            addCriterion("pay_type in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotIn(List<String> values) {
            addCriterion("pay_type not in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeBetween(String value1, String value2) {
            addCriterion("pay_type between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotBetween(String value1, String value2) {
            addCriterion("pay_type not between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andGrantStatusIsNull() {
            addCriterion("grant_status is null");
            return (Criteria) this;
        }

        public Criteria andGrantStatusIsNotNull() {
            addCriterion("grant_status is not null");
            return (Criteria) this;
        }

        public Criteria andGrantStatusEqualTo(String value) {
            addCriterion("grant_status =", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusNotEqualTo(String value) {
            addCriterion("grant_status <>", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusGreaterThan(String value) {
            addCriterion("grant_status >", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusGreaterThanOrEqualTo(String value) {
            addCriterion("grant_status >=", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusLessThan(String value) {
            addCriterion("grant_status <", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusLessThanOrEqualTo(String value) {
            addCriterion("grant_status <=", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusLike(String value) {
            addCriterion("grant_status like", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusNotLike(String value) {
            addCriterion("grant_status not like", value, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusIn(List<String> values) {
            addCriterion("grant_status in", values, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusNotIn(List<String> values) {
            addCriterion("grant_status not in", values, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusBetween(String value1, String value2) {
            addCriterion("grant_status between", value1, value2, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andGrantStatusNotBetween(String value1, String value2) {
            addCriterion("grant_status not between", value1, value2, "grantStatus");
            return (Criteria) this;
        }

        public Criteria andCodeUrlIsNull() {
            addCriterion("code_url is null");
            return (Criteria) this;
        }

        public Criteria andCodeUrlIsNotNull() {
            addCriterion("code_url is not null");
            return (Criteria) this;
        }

        public Criteria andCodeUrlEqualTo(String value) {
            addCriterion("code_url =", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlNotEqualTo(String value) {
            addCriterion("code_url <>", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlGreaterThan(String value) {
            addCriterion("code_url >", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlGreaterThanOrEqualTo(String value) {
            addCriterion("code_url >=", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlLessThan(String value) {
            addCriterion("code_url <", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlLessThanOrEqualTo(String value) {
            addCriterion("code_url <=", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlLike(String value) {
            addCriterion("code_url like", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlNotLike(String value) {
            addCriterion("code_url not like", value, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlIn(List<String> values) {
            addCriterion("code_url in", values, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlNotIn(List<String> values) {
            addCriterion("code_url not in", values, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlBetween(String value1, String value2) {
            addCriterion("code_url between", value1, value2, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andCodeUrlNotBetween(String value1, String value2) {
            addCriterion("code_url not between", value1, value2, "codeUrl");
            return (Criteria) this;
        }

        public Criteria andScanCodeIsNull() {
            addCriterion("scan_code is null");
            return (Criteria) this;
        }

        public Criteria andScanCodeIsNotNull() {
            addCriterion("scan_code is not null");
            return (Criteria) this;
        }

        public Criteria andScanCodeEqualTo(String value) {
            addCriterion("scan_code =", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeNotEqualTo(String value) {
            addCriterion("scan_code <>", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeGreaterThan(String value) {
            addCriterion("scan_code >", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeGreaterThanOrEqualTo(String value) {
            addCriterion("scan_code >=", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeLessThan(String value) {
            addCriterion("scan_code <", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeLessThanOrEqualTo(String value) {
            addCriterion("scan_code <=", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeLike(String value) {
            addCriterion("scan_code like", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeNotLike(String value) {
            addCriterion("scan_code not like", value, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeIn(List<String> values) {
            addCriterion("scan_code in", values, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeNotIn(List<String> values) {
            addCriterion("scan_code not in", values, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeBetween(String value1, String value2) {
            addCriterion("scan_code between", value1, value2, "scanCode");
            return (Criteria) this;
        }

        public Criteria andScanCodeNotBetween(String value1, String value2) {
            addCriterion("scan_code not between", value1, value2, "scanCode");
            return (Criteria) this;
        }

        public Criteria andTimeExpireIsNull() {
            addCriterion("time_expire is null");
            return (Criteria) this;
        }

        public Criteria andTimeExpireIsNotNull() {
            addCriterion("time_expire is not null");
            return (Criteria) this;
        }

        public Criteria andTimeExpireEqualTo(Date value) {
            addCriterion("time_expire =", value, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireNotEqualTo(Date value) {
            addCriterion("time_expire <>", value, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireGreaterThan(Date value) {
            addCriterion("time_expire >", value, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireGreaterThanOrEqualTo(Date value) {
            addCriterion("time_expire >=", value, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireLessThan(Date value) {
            addCriterion("time_expire <", value, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireLessThanOrEqualTo(Date value) {
            addCriterion("time_expire <=", value, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireIn(List<Date> values) {
            addCriterion("time_expire in", values, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireNotIn(List<Date> values) {
            addCriterion("time_expire not in", values, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireBetween(Date value1, Date value2) {
            addCriterion("time_expire between", value1, value2, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andTimeExpireNotBetween(Date value1, Date value2) {
            addCriterion("time_expire not between", value1, value2, "timeExpire");
            return (Criteria) this;
        }

        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria) this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria) this;
        }

        public Criteria andVersionEqualTo(Integer value) {
            addCriterion("version =", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotEqualTo(Integer value) {
            addCriterion("version <>", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThan(Integer value) {
            addCriterion("version >", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(Integer value) {
            addCriterion("version >=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThan(Integer value) {
            addCriterion("version <", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThanOrEqualTo(Integer value) {
            addCriterion("version <=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionIn(List<Integer> values) {
            addCriterion("version in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotIn(List<Integer> values) {
            addCriterion("version not in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionBetween(Integer value1, Integer value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotBetween(Integer value1, Integer value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIsNull() {
            addCriterion("refund_number is null");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIsNotNull() {
            addCriterion("refund_number is not null");
            return (Criteria) this;
        }

        public Criteria andRefundNumberEqualTo(String value) {
            addCriterion("refund_number =", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotEqualTo(String value) {
            addCriterion("refund_number <>", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberGreaterThan(String value) {
            addCriterion("refund_number >", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberGreaterThanOrEqualTo(String value) {
            addCriterion("refund_number >=", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLessThan(String value) {
            addCriterion("refund_number <", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLessThanOrEqualTo(String value) {
            addCriterion("refund_number <=", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLike(String value) {
            addCriterion("refund_number like", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotLike(String value) {
            addCriterion("refund_number not like", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIn(List<String> values) {
            addCriterion("refund_number in", values, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotIn(List<String> values) {
            addCriterion("refund_number not in", values, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberBetween(String value1, String value2) {
            addCriterion("refund_number between", value1, value2, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotBetween(String value1, String value2) {
            addCriterion("refund_number not between", value1, value2, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andGrantTimeIsNull() {
            addCriterion("grant_time is null");
            return (Criteria) this;
        }

        public Criteria andGrantTimeIsNotNull() {
            addCriterion("grant_time is not null");
            return (Criteria) this;
        }

        public Criteria andGrantTimeEqualTo(Date value) {
            addCriterion("grant_time =", value, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeNotEqualTo(Date value) {
            addCriterion("grant_time <>", value, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeGreaterThan(Date value) {
            addCriterion("grant_time >", value, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("grant_time >=", value, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeLessThan(Date value) {
            addCriterion("grant_time <", value, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeLessThanOrEqualTo(Date value) {
            addCriterion("grant_time <=", value, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeIn(List<Date> values) {
            addCriterion("grant_time in", values, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeNotIn(List<Date> values) {
            addCriterion("grant_time not in", values, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeBetween(Date value1, Date value2) {
            addCriterion("grant_time between", value1, value2, "grantTime");
            return (Criteria) this;
        }

        public Criteria andGrantTimeNotBetween(Date value1, Date value2) {
            addCriterion("grant_time not between", value1, value2, "grantTime");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNull() {
            addCriterion("updated_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNotNull() {
            addCriterion("updated_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByEqualTo(String value) {
            addCriterion("updated_by =", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotEqualTo(String value) {
            addCriterion("updated_by <>", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThan(String value) {
            addCriterion("updated_by >", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThanOrEqualTo(String value) {
            addCriterion("updated_by >=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThan(String value) {
            addCriterion("updated_by <", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThanOrEqualTo(String value) {
            addCriterion("updated_by <=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLike(String value) {
            addCriterion("updated_by like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotLike(String value) {
            addCriterion("updated_by not like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIn(List<String> values) {
            addCriterion("updated_by in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotIn(List<String> values) {
            addCriterion("updated_by not in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByBetween(String value1, String value2) {
            addCriterion("updated_by between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotBetween(String value1, String value2) {
            addCriterion("updated_by not between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}